<?php

namespace App\DataTables;

use App\Models\Flange;
use App\Models\FlangeNozzleCategory;
use Illuminate\Database\Eloquent\Builder as QueryBuilder;
use Yajra\DataTables\EloquentDataTable;
use Yajra\DataTables\Html\Builder as HtmlBuilder;
use Yajra\DataTables\Html\Button;
use Yajra\DataTables\Html\Column;
use Yajra\DataTables\Html\Editor\Editor;
use Yajra\DataTables\Html\Editor\Fields;
use Yajra\DataTables\Services\DataTable;

class FlangeDataTable extends DataTable
{
    /**
     * Build the DataTable class.
     *
     * @param QueryBuilder<Flange> $query Results from query() method.
     */
    public function dataTable(QueryBuilder $query): EloquentDataTable
    {
        return (new EloquentDataTable($query))
        ->editColumn('category', function ($query) {
                return FlangeNozzleCategory::where('id','=',$query->fcategoryid)->pluck('categoryname')->first();
        })
        ->addColumn('action', function($query){
                // view Button
                $viewButton = "";
                $viewButton = '<a href="'.route('admin/flange/nozzle/show',$query->id).'" class="btn btn-grd btn-grd-royal btn-sm"><i class="lni lni-eye"></i></a>';
                $updateButton = "";
                $updateButton = '<a href="'.route('admin/flange/nozzle/edit',$query->id).'" class="btn btn-grd btn-grd-warning btn-sm"><i class="lni lni-pencil-alt"></i></a>';
                $deleteButton = "";
                $deleteButton = "<a class='delete btn btn-grd btn-grd-danger btn-sm' title='Delete' data-toggle='tooltip' data-id='".$query->id."'><i class='lni lni-trash'></i></a>";
                return $viewButton." ".$updateButton." ".$deleteButton;
            })
            ->rawColumns(['category','action']);
    }

    /**
     * Get the query source of dataTable.
     *
     * @return QueryBuilder<Flange>
     */
    public function query(Flange $model): QueryBuilder
    {
        return $model->newQuery()->orderby('id','asc');
    }

    /**
     * Optional method if you want to use the html builder.
     */
    public function html(): HtmlBuilder
    {
        return $this->builder()
                    ->setTableId('flange-table')
                    ->columns($this->getColumns())
                    ->minifiedAjax()
                    ->orderBy(1)
                    ->selectStyleSingle()
                    ->buttons([
                        // Button::make('excel'),
                        // Button::make('csv'),
                        // Button::make('pdf'),
                        // Button::make('print'),
                        // Button::make('reset'),
                        // Button::make('reload')
                    ]);
    }

    /**
     * Get the dataTable columns definition.
     */
    public function getColumns(): array
    {
        return [
            'fnb' => ['data' => 'fnb', 'name' => 'fnb', 'title' => 'NB'],
            'fclassvalue' => ['data' => 'fclassvalue', 'name' => 'fclassvalue', 'title' => 'Class Value'],
            'category' => ['data' => 'category', 'name' => 'category', 'title' => 'Category Name'],
            'value' => ['data' => 'value', 'name' => 'value', 'title' => 'Value'],
            Column::computed('action')
                  ->exportable(false)
                  ->printable(false)
                  ->width(120)
                  ->addClass('text-center'),
            // Column::make('id'),
            // Column::make('add your columns'),
            // Column::make('created_at'),
            // Column::make('updated_at'),
        ];
    }

    /**
     * Get the filename for export.
     */
    protected function filename(): string
    {
        return 'Flange_' . date('YmdHis');
    }
}
